#include <stdio.h>

typedef struct _cntr_line_struct {
  int color;
  int npoints;
  float *x;
  float *y;
  struct _cntr_line_struct *next;
} Cntr_line;

/***********************************************************/
Cntr_line *ctr_line=NULL;

int main(int argc, char *argv[])
{

  float *z;
  float *x;
  float *y;
  int i;
  int k;
  int nx;
  int ny;
  int ncol;
  int nxy;
  FILE *fp;
  Cntr_line *cline;
  int compute_contour(float *, float *, float *, int, int, int );


  ncol = 16;

  fp = fopen("xfarbe.dat","r");
  if (fp == NULL) {
    fprintf(stderr,"ERROR: cannot open file %s\n", "xfarbe.dat");
    exit (-1);
  }
  fscanf(fp,"%d %d", &nx, &ny);
  nxy = nx*ny;

  z = (float *)malloc(nxy*sizeof(z[0]));
  x = (float *)malloc((nx+1) *sizeof(x[0]));
  y = (float *)malloc((ny+1) *sizeof(y[0]));

  for (i=0; i<nxy; i++) {
    fscanf(fp,"%f",&z[i]);
  }
  fclose(fp);

  for (i=0; i<=nx; i++) {
    x[i]=i;
  }

  for (i=0; i<=ny; i++) {
    y[i]=i;
  }



  compute_contour(z, x, y, nx, ny, ncol);

  for (cline=ctr_line; cline != NULL; cline=cline->next) {

    k = (cline->npoints>5?5:cline->npoints);
    printf("pltline with %d points, color %d:",cline->npoints, cline->color);
    for (i=0; i<k; i++) printf(" %5.2f",cline->x[i]);
    printf("\n");
  }
  return 0;
}


