#include <stdio.h>
#include <math.h>

main()
{
  int ncol;
  int nc;
  int n;
  float z[100];
  float cntr_lvl[32]; 
  int i;
  void auto_cntr_levels(float *, int, int, float *, int *);
  
  ncol = 10;
  
  for (i=0;i<n; i++) {
    z[i] = 100.0 * rand() / 65536.0;
  }
  auto_cntr_levels(z, n, ncol, cntr_lvl, &nc);
  printf("N=%d\n",nc);
  
  for (i=0;i<nc; i++) {
    printf("%g\n",cntr_lvl[i]);
  }
  
}
  
#define MIN(a,b) ((a) < (b) ? (a): (b))
#define MAX(a,b) ((a) > (b) ? (a): (b))

void auto_cntr_levels(float *z, int n, int ncol, float *cntr_lvl, int *nc)
{
 
  double cincr, cstart;
  double zmin, zmax;
  double zdif, dif;
  int log1;
  int i;
  double r_lg10(double), r_mod(double, double), pow_ri(double, int);

  *nc = ncol - 1;

  zmin = zmax = z[0];
  for (i=1; i<n; i++) {
    zmin = MIN(zmin, z[i]);
    zmax = MAX(zmin, z[i]);
  }

printf("ZMIN=%g, ZMAX=%g\n",zmin,zmax);
/*     COMPUTE INCREMENT CINCR FOR CONTOUR VALUES */
  zdif = zmax - zmin;
  cincr = zdif / (*nc);
  if (cincr < (double)1.) {
    cincr *= (double).1;
  }
  log1 = r_lg10(cincr) + (double)1.;
  cincr = pow_ri((double)10.0, log1);
  printf("incr=%g\n",cincr);
 L100:
  dif = ncol * cincr - zdif;
  if (dif > zdif) {
    cincr *= (double).5;
    printf("Incr=%g\n",cincr);
  }
  if (dif > zdif) {
    goto L100;
  }
  
  /*     ROUNDED STARTING VALUE */
  cstart = zmin - r_mod(zmin,cincr);
  if (zmin > (double)0.) {
    cstart += cincr;
  }
  
  *nc = (zmax - cstart) / cincr + 1;
printf("Desired NC=%d\n", *nc);
  if ((*nc) > ncol-1)  *nc = ncol-1;
  
  /*       = NUMBER OF CONTOUR LEVELS */
  
  /*     CONTOUR LEVELS */
  for (i = 0; i < (*nc); ++i) {
    cntr_lvl[i] =  cstart + i * cincr;
  }
  
}

double pow_ri(double ap, int bp)
{
double pow, x;
int n;

pow = 1;
x = ap;
n = bp;

if(n != 0)
	{
	if(n < 0)
		{
		if(x == 0)
			{
			return(pow);
			}
		n = -n;
		x = 1/x;
		}
	for( ; ; )
		{
		if(n & 01)
			pow *= x;
		if(n >>= 1)
			x *= x;
		else
			break;
		}
	}
return(pow);
}


#define log10e 0.43429448190325182765

double r_lg10(double x)
{
double log();

return( log10e * log(x) );
}

double r_mod(x,y)
double x, y;
{
#ifdef IEEE_drem
	double drem(), xa, ya, z;
	if ((ya = y) < 0.)
		ya = -ya;
	z = drem(xa = x, ya);
	if (xa > 0) {
		if (z < 0)
			z += ya;
		}
	else if (z > 0)
		z -= ya;
	return z;
#else
	double floor(), quotient;
	if( (quotient = (double)x / y) >= 0)
		quotient = floor(quotient);
	else
		quotient = -floor(-quotient);
	return(x - y * quotient );
#endif
}
