#!/bin/ksh
#
# copy_libs.csh
#
# SRT 960508
#
# Copies Todd Plessel et. al.'s Map and associated libs into the EDSS lib dirs,
# both the 0.x and the 0.3pre

   PROJDIR=/project/models3/unofficial/development/Models3Vis/code/External/lib
MAPUTILDIR=/project/models3/unofficial/development/Models3Vis/code/VisualizationSubsystem/lib

for EDSS in EDSSv0.x EDSSv0.3pre
do
  for ARCHITECTURE in IBM SGI DEC SUN HP 
    do

      echo -----------------------------------------------------------
      echo NOW DOING $EDSS $ARCHITECTURE LIBS
      echo -----------------------------------------------------------

      if [ $ARCHITECTURE = "DEC" ]
      then
	INSTALL_DIR="/pub/storage/edss/framework/$EDSS/OSF1_alpha/lib/OPTIMIZE"
	FROMDIR="OSF1"


      elif [ $ARCHITECTURE = "SUN" ]
      then
	INSTALL_DIR="/pub/storage/edss/framework/$EDSS/SunOS5_sparc/lib/OPTIMIZE"
	FROMDIR="SunOS"


      elif [ $ARCHITECTURE = "HP" ]
      then
	INSTALL_DIR="/pub/storage/edss/framework/$EDSS/HP_UX9_9000/lib/OPTIMIZE"
	FROMDIR="HP-UX"


      elif [ $ARCHITECTURE = "IBM" ]
      then
	INSTALL_DIR="/pub/storage/edss/framework/$EDSS/AIX4_rs6000/lib/OPTIMIZE"
	FROMDIR="AIX"


      elif [ $ARCHITECTURE = "SGI" ]
      then
	INSTALL_DIR="/pub/storage/edss/framework/$EDSS/IRIX5_mips/lib/OPTIMIZE"
	FROMDIR="IRIX"
      fi
      ls -al "$PROJDIR/$FROMDIR/libproj.a"
      echo cp "$PROJDIR/$FROMDIR/libproj.a" "$INSTALL_DIR"
           cp "$PROJDIR/$FROMDIR/libproj.a" "$INSTALL_DIR"
      ls -al "$INSTALL_DIR/libproj.a"
      echo
      for LIBRARY in libError.a libFile.a libMapFile.a libDataImport.a \
		     libMapUtilities.a libMapProjections.a libMemory.a
      do
	ls -al "$MAPUTILDIR/$FROMDIR/$LIBRARY"
	echo cp "$MAPUTILDIR/$FROMDIR/$LIBRARY" "$INSTALL_DIR"
	     cp "$MAPUTILDIR/$FROMDIR/$LIBRARY" "$INSTALL_DIR"
        ls -al "$INSTALL_DIR/$LIBRARY"
        echo
      done
    done
done
