/****************************************************************************
 *
 * Project Title: Environmental Decision Support System
 *
 *         File: @(#)free_vis.c	2.1
 *     Pathname: /env/proj/archive/edss/src/pave/pave_io/SCCS/s.free_vis.c
 * Last updated: 12/15/97 16:30:16
 *
 * Made available by MCNC and the Carolina Environmental Program of UNC Chapel
 * Hill under terms of the GNU Public License.  See gpl.txt for more details.
 *
 * See file COPYRIGHT for license information on this and supporting software.
 *
 * Carolina Environmental Program
 * University of North Carolina at Chapel Hill
 * 137 E. Franklin St.
 * Chapel Hill, NC 27599-6116
 *
 * See http://www.cep.unc.edu, http://www.cmascenter.org, http://bugz.unc.edu
 *
 ****************************************************************************/

static const char *SCCS_ID = "@(#)free_vis.c	2.1 /env/proj/archive/edss/src/pave/pave_io/SCCS/s.free_vis.c 12/15/97 16:30:16";

/*****************************************************************************/
/* Author:	Kathy Pearson, MCNC, kathyp@mcnc.org, (919) 248-9240         */
/* Date:	December 12, 1994                                            */
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <assert.h>
#include "netcdf.h"
#include "vis_data.h"

/* This function frees the malloced pointers in the VIS_DATA structure */
void free_vis(VIS_DATA *info)
{
register int i;

if (!info) return; /* Added 960419 SRT */

/* free double pointer sources */

for (i = 0; i < (*info).nspecies; i++)
    {
	if ((*info).species_short_name != NULL)
		if ((*info).species_short_name[i] != NULL)
			free((*info).species_short_name[i]);
	if ((*info).species_long_name != NULL)
		if ((*info).species_long_name[i] != NULL)
			free((*info).species_long_name[i]);
	if ((*info).units_name != NULL)
		if ((*info).units_name[i] != NULL)
			free((*info).units_name[i]);
	}

/* free pointer allocated by user */

if ((*info).filename != NULL)
	free((*info).filename);

/* free other pointers */

if ((*info).species_short_name != NULL)
	free((*info).species_short_name);
if ((*info).species_long_name != NULL)
	free((*info).species_long_name);
if ((*info).units_name != NULL)
	free((*info).units_name);
if ((*info).map_info != NULL)
	free((*info).map_info);
if ((*info).data_label != NULL)
	free((*info).data_label);
if ((*info).grid != NULL)
	free((*info).grid);
if ((*info).sdate != NULL)
	free ((*info).sdate);
if ((*info).stime != NULL)
	free ((*info).stime);

/* free host pointers */
if ((*info).filehost.ip != NULL)
	free((*info).filehost.ip);
if ((*info).filehost.name != NULL)
	free((*info).filehost.name);

memset ((void *) info, NULL, (size_t) sizeof(VIS_DATA)); /* SRT 061395 */
}

