/****************************************************************************
 *
 * Project Title: Environmental Decision Support System
 *
 *         File: @(#)migrate.c	2.1
 *     Pathname: /env/proj/archive/edss/src/pave/pave_io/SCCS/s.migrate.c
 * Last updated: 12/15/97 16:30:24
 *
 * Made available by MCNC and the Carolina Environmental Program of UNC Chapel
 * Hill under terms of the GNU Public License.  See gpl.txt for more details.
 *
 * See file COPYRIGHT for license information on this and supporting software.
 *
 * Carolina Environmental Program
 * University of North Carolina at Chapel Hill
 * 137 E. Franklin St.
 * Chapel Hill, NC 27599-6116
 *
 * See http://www.cep.unc.edu, http://www.cmascenter.org, http://bugz.unc.edu
 *
 ****************************************************************************/

static const char *SCCS_ID = "@(#)migrate.c	2.1 /env/proj/archive/edss/src/pave/pave_io/SCCS/s.migrate.c 12/15/97 16:30:24";

/*****************************************************************************/
/* Author:	Kathy Pearson, MCNC, kathyp@mcnc.org, (919) 248-9240         */
/*****************************************************************************/
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>

/*
#define UNICOS 1
*/

int get_migrate_state(char *filename, int *online, int *offline)
{
struct stat statbuf;
int istat;

#define IOERROR -1

if ((istat = stat(filename, &statbuf)) != IOERROR)
	{
#ifdef UNICOS
	if (statbuf.st_dm_state == S_DMS_REGULAR)
		{
		*online = 1;
		*offline = 0;
		}
	else if (statbuf.st_dm_state == S_DMS_OFFLINE)
		{
		*online = 0;
		*offline = 1;
		}
	else if (statbuf.st_dm_state == S_DMS_DUALSTATE)
		{
		*online = 1;
		*offline = 1;
		}
#else
	*online = 1;
	*offline = 0;
#endif
	return(1);
	}
return(0);
}

