#include "Alias.h"


Alias::Alias(char *name, int ntoken, char **token, int *tflag)
{
  int i;

  name_ = strdup(name);
  ntoken_ = ntoken;
  token_ = NULL;
  tflag_ = NULL;
  if (ntoken > 0) {
    token_ = (char **)malloc(ntoken*sizeof(char *));
    tflag_ = (int *)malloc(ntoken*sizeof(int));
    if (token_ == NULL || tflag_ == NULL) {
      fprintf(stderr,"Allocation error in Alias\n");
      return;
    }
    for (i=0; i<ntoken; i++) {
      tflag_[i] = tflag[i];
      token_[i] = strdup(token[i]);
    }
  }

}

Alias::~Alias()
{
  int i;

  if (ntoken_ > 0) {
    for (i=0; i<ntoken_; i++) {
      if (token_[i]) free(token_[i]);
    }
    free(token_);
    free(tflag_);
    free(name_);
  }
}


int Alias::match(void *target)
{
  char *targetName = (char *) target;

  return (!strcmp(targetName, name_));

}

char *Alias::getClassName(void)
{
  static char *name="Alias";
  return name;
}
  
void Alias::print(FILE *output)
{
  int i;
  fprintf(output,"%s=",name_);

  for (i=0;i<ntoken_;i++) {

    //    if(token_[i]) fprintf(output,"%s",token_[i]);
    //    if(tflag_[i]) fprintf(output,"<case>");
    fprintf(output,"%s",token_[i]);
  }

  fprintf(output,"\n");
  
}



