/****************************************************************************
 *
 * Project Title: Environmental Decision Support System
 *
 *         File: @(#)AppInit.cc	2.1
 *     Pathname: /env/proj/archive/edss/src/pave/pave_motif/SCCS/s.AppInit.cc
 * Last updated: 12/15/97 16:31:36
 *
 * Made available by MCNC and the Carolina Environmental Program of UNC Chapel
 * Hill under terms of the GNU Public License.  See gpl.txt for more details.
 *
 * See file COPYRIGHT for license information on this and supporting software.
 *
 * Carolina Environmental Program
 * University of North Carolina at Chapel Hill
 * 137 E. Franklin St.
 * Chapel Hill, NC 27599-6116
 *
 * See http://www.cep.unc.edu, http://www.cmascenter.org, http://bugz.unc.edu
 *
 ****************************************************************************/

static const char *SCCS_ID = "@(#)AppInit.cc	2.1 /env/proj/archive/edss/src/pave/pave_motif/SCCS/s.AppInit.cc 12/15/97 16:31:36";

///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////
// AppInit.C: 
////////////////////////////////////////////////////////////
#include "AppInit.h"


AppInit::AppInit ( char *appClassName ) : 
                    UIComponent ( appClassName )
{
    
    // Initialize data members
    
    display_    = (Display *) NULL;
    appContext_ = (XtAppContext) NULL;
    applicationClass_ = strdup ( appClassName );
}

#if (XlibSpecificationRelease>=5)
void AppInit::initialize ( int *argcp, char **argv )
#else
void AppInit::initialize ( unsigned int *argcp, char **argv )
#endif
{
    _w = XtAppInitialize ( &appContext_, 
			  applicationClass_, NULL, 0, 
			  argcp, argv, 
			  NULL, NULL, 0 );
    
    // Extract and save a pointer to the X display structure
    
    display_ = XtDisplay ( _w );
    
    // The AppInit class is less likely to need to handle
    // "surprise" widget destruction than other classes, but
    // we might as well install a callback to be safe and consistent
    
    installDestroyHandler();
    
    // Center the shell, and make sure it isn't visible

    XtVaSetValues ( _w,
		   XmNmappedWhenManaged, FALSE,
		   XmNx, DisplayWidth ( display_, 0 ) / 2,
		   XmNy, DisplayHeight ( display_, 0 ) / 2,
		   XmNwidth,  1,
		   XmNheight, 1,
		   NULL );

    // The instance name of this object was set in the UIComponent 
    // constructor, before the name of the program was available
    // Free the old name and reset it to argv[0]
    
    if (_name) /* SRT delete _name */  free(_name); _name = (char *) NULL;
    _name = strdup ( argv[0] );
    
    // Force the shell window to exist so dialogs popped up from
    // this shell behave correctly
    XtRealizeWidget ( _w );

}

AppInit::~AppInit()
{
    delete applicationClass_;
}

void AppInit::handleEvents()
{
    // Just loop forever
    
    XtAppMainLoop ( appContext_ );
}

